<template>
  <div class="parameterConfiguration_box box_div">
    <My-bread :list="[
        `${$t('operatManage.operatManage')}`,
        `${$t('operatManage.systemLayout')}`,
      ]"></My-bread>
    <el-divider />
    <div
      class="table_box"
      :style="styleVar"
    >
      <el-table
        ref="filterTable"
        :data="tableData"
        style="width: 100%"
        border
        height="calc(100% - 45px)"
      >
        <el-table-column
          align="center"
          type="index"
          :label="$t('operatManage.ELM.index')"
          width="70px"
        />
        <el-table-column
          prop="name"
          align="center"
          :label="$t('operatManage.sysLayOutObj.name')"
        />
        <el-table-column
          prop="cvalue"
          align="center"
          :label="$t('operatManage.sysLayOutObj.cvalue')"
        />
        <el-table-column
          prop="dvalue"
          align="center"
          :label="$t('operatManage.sysLayOutObj.dvalue')"
        />
        <el-table-column
          prop="minValue"
          align="center"
          :label="$t('operatManage.sysLayOutObj.minValue')"
        />
        <el-table-column
          prop="maxValue"
          align="center"
          :label="$t('operatManage.sysLayOutObj.maxValue')"
        />
        <el-table-column
          prop="descr"
          align="center"
          :label="$t('operatManage.sysLayOutObj.descr')"
        />
        <el-table-column
          v-if="menuStatus.update"
          fixed="right"
          :label="$t('common.operate')"
          width="100px"
        >
          <template slot-scope="scope">
            <el-button
              @click="showDetail(scope.$index, scope.row)"
              type="warning"
              plain
              size="small"
            >{{ $t("common.edit") }}</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div
        class="pagination_box"
        style="margin-top: 10px"
      >
        <el-pagination
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
          :current-page="listData.pageIndex"
          :page-sizes="[10, 20, 50, 100]"
          :page-size="listData.pageSize"
          layout="total, sizes, prev, pager, next, jumper"
          :total="count"
        >
        </el-pagination>
      </div>
    </div>

    <el-dialog
      :title="$t('operatManage.sysLayOutObj.editSysLayOut')"
      top="2vh"
      :visible.sync="EditFormdialog"
      :before-close="EditFromDataClose"
    >
      <div style="height: 500px; overflow: auto">
        <el-form
          :model="upform"
          label-position="top"
        >
          <el-form-item
            :label="$t('operatManage.sysLayOutObj.name')"
            :label-width="formLabelWidth"
          >
            <label class="boxlabel">{{ upform.name }}</label>
          </el-form-item>
          <el-form-item
            :label="$t('operatManage.sysLayOutObj.cvalue')"
            :label-width="formLabelWidth"
          >
            <el-input
              v-model="upform.cvalue"
              autocomplete="off"
              style="width:85%"
            ></el-input>
          </el-form-item>
          <el-form-item
            :label="$t('operatManage.sysLayOutObj.dvalue')"
            :label-width="formLabelWidth"
          >
            <label class="boxlabel">{{ upform.dvalue }}</label>
          </el-form-item>
          <el-form-item
            :label="$t('operatManage.sysLayOutObj.minValue')"
            :label-width="formLabelWidth"
          >
            <label class="boxlabel">{{ upform.minValue }}</label>
          </el-form-item>
          <el-form-item
            :label="$t('operatManage.sysLayOutObj.maxValue')"
            :label-width="formLabelWidth"
          >
            <label class="boxlabel">{{ upform.maxValue }}</label>
          </el-form-item>
          <el-form-item
            :label="$t('operatManage.sysLayOutObj.descr')"
            :label-width="formLabelWidth"
          >
            <label class="boxlabel">{{ upform.descr }}</label>
          </el-form-item>
        </el-form>
      </div>
      <div
        slot="footer"
        class="dialog-footer"
      >
        <el-button
          size="small"
          @click="EditFromDataClose"
        >{{
          $t("common.close")
        }}</el-button>
        <el-button
          @click="EditFromData"
          size="small"
          type="primary"
        >{{
          $t("common.confirm")
        }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import MyBread from "../../components/MyBread.vue";
import { select_Args_ByPageAndCount, update_args } from "../../api/api.js";
export default {
  //import引入的组件需要注入到对象中才能使用
  components: {
    MyBread,
  },

  data() {
    return {
      menuStatus: {
        delete: false,
        insert: false,
        update: false,
      },
      formLabelWidth: "120px",
      upform: {},
      EditFormdialog: false,
      tableData: [],
      count: 0,
      listData: {
        name: "",
        pageIndex: 1,
        pageSize: 10,
      },
      tableHeight: 0,
      timer: 0,
      styleVar: {
        height: "calc(100% - 30px)",
      },
    };
  },
  methods: {
    handleSizeChange(val) {
      this.listData.pageSize = val;
      this.getRoleTabelData();
    },
    handleCurrentChange(val) {
      this.listData.pageIndex = val;
      this.getRoleTabelData();
    },
    showDetail(index, row) {
      this.EditFormdialog = true;
      this.upform = row;
    },
    EditFromDataClose() {
      this.EditFormdialog = false;
      this.upform = {};
    },
    async EditFromData() {
      if (
        parseInt(this.upform.cvalue) < parseInt(this.upform.minValue) ||
        parseInt(this.upform.cvalue) > parseInt(this.upform.maxValue)
      ) {
        this.$message({
          message: "当前值不能小于最小值或大于最大值!",
          type: "warning",
        });
        return;
      }

      var val_data = await update_args(this.upform);
      if (val_data.code == 200) {
        this.uploadFile = val_data.result;

        this.$message({
          message: "修改成功！",
          type: "success",
        });
        this.getRoleTabelData();
        this.EditFormdialog = false;
        this.upform = {};
      } else {
        this.$message({
          message: "修改失败！",
          type: "warning",
        });
      }
    },
    async getRoleTabelData() {
      if (this.listData.tab == "") {
        delete this.listData.tab;
      }
      const data = await select_Args_ByPageAndCount(this.listData);
      if (data.code != 200) {
        this.$message.error("列表调用失败");
      }
      console.log(data);
      this.tableData = data.result;
      this.count = data.count;
    },
    showPermsMenu(res) {
      switch (res.tag) {
        case "/delete":
          this.menuStatus.delete = true;
          break;
        case "/insert":
          this.menuStatus.insert = true;
          break;
        case "/update":
          this.menuStatus.update = true;
          break;
      }
    },
  },
  created() {
    var val = this.$store.state.currentPerms;
    var permsEntity = this.$store.state.permsEntity;
    for (var i = 0; i < permsEntity.length; i++) {
      if (permsEntity[i].perms == val) {
        this.showPermsMenu(permsEntity[i]);
      }
    }
    this.getRoleTabelData();
  },
};
</script>
<style lang="less" scoped>
//@import url(); 引入公共css类
.parameterConfiguration_box {
  height: calc(100% - 20px);
  width: calc(100% - 20px);
  padding: 10px;
  position: relative;
  .parameterConfiguration {
    padding-top: 10px;
    padding-bottom: 10px;
    height: 88%;
    overflow: auto;
    border-radius: 5px;

    box-sizing: border-box;
    .el-select {
      width: 100%;
    }
    .flex_box {
      display: flex;
      justify-content: center;
    }
  }
}
</style>
